Modules/Core/Routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;


Auth::routes(['register'=>false]);


Route::group(["prefix"=>'password'],function (){

    Route::post('/reset', 'Auth\ForgotPasswordController@showLinkRequestForm')->name('password.request');
    Route::post('/email', 'Auth\ForgotPasswordController@sendResetLinkEmail')->name('password.email');
    Route::get('/reset/{token}', 'Auth\ResetPasswordController@showResetForm')->name('password.reset');
    Route::post('/final/reset', 'Auth\ResetPasswordController@reset')->name('password.update');
});


Route::feeds();


    Route::group(["prefix"=>config('cms.prefix-admin'), "middleware" => ["auth:web"]], function () {
        Route::get('/', 'CoreController@index')->name('dashboard.website');
        Route::get('/setting', 'SettingController@setting')->name('dashboard.setting.index');
        Route::get('/template', 'SettingController@template')->name('dashboard.template.index');
        Route::patch('/setting/update', 'SettingController@settingUpdate')->name('dashboard.setting.update');
        Route::resource('/roles','RoleController');
        Route::resource('/currencies','CurrencyController');
        Route::get('/contacts', 'ContactController@index')->name('contacts.index');
        Route::get('/contacts/{contact}/edit', 'ContactController@edit')->name('contacts.edit');
        Route::delete('/contacts/{contact}', 'ContactController@destroy')->name('contacts.destroy');

        Route::group(["prefix"=>'search'], function () {
            Route::post('/contact', 'ContactController@search')->name('search.contact');
            Route::post('/currency', 'CurrencyController@search')->name('search.currency');
        });

    });

    Route::post('/contacts', 'ContactController@store')->name('contacts.store');

Modules/Core/Http/Controllers/RoleController.php
<?php

namespace Modules\Core\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;
use Modules\Article\Entities\Article;
use Modules\Brand\Entities\Brand;
use Modules\Carousel\Entities\Carousel;
use Modules\Client\Entities\Client;
use Modules\Core\Entities\Currency;
use Modules\Core\Entities\User;
use Modules\Core\Http\Requests\RoleRequest;
use Modules\Customer\Entities\Customer;
use Modules\Download\Entities\Download;
use Modules\Event\Entities\Event;
use Modules\Information\Entities\Information;
use Modules\Member\Entities\Member;
use Modules\Menu\Entities\Menu;
use Modules\Page\Entities\Page;
use Modules\Plan\Entities\Plan;
use Modules\Portfolio\Entities\Portfolio;
use Modules\Product\Entities\Product;
use Modules\Question\Entities\Question;
use Modules\Service\Entities\Advantage;
use Modules\Service\Entities\Property;
use Modules\Service\Entities\Service;
use Modules\Sms\Entities\Sms;
use Modules\Store\Entities\Store;
use Nwidart\Modules\Facades\Module;
use Spatie\Permission\Models\Permission;
use Spatie\Permission\Models\Role;

class RoleController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    protected $entity;


    function __construct()
    {
        $this->entity=new Role();
        $this->middleware('permission:role-list')->only(['only'=>['index']]);
        $this->middleware('permission:role-create')->only(['create','store']);
        $this->middleware('permission:role-edit' )->only(['edit','update']);
        $this->middleware('permission:role-delete')->only(['destroy']);
    }


    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        try {
            $items = $this->entity->orderBy('id','DESC')->paginate(config('cms.paginate'));
            return view('core::layout.roles.index',compact('items'));
        }catch (\Exception $exception){
            return abort('500');
        }


    }


    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        try {
            if(hasModule('Article')){
                $permission_articles = Permission::whereModel(Article::class)->get();
            }
            if(hasModule('Information')){
                $permission_informations = Permission::whereModel(Information::class)->get();
            }
            if(hasModule('Menu')){
                $permission_menus = Permission::whereModel(Menu::class)->get();
            }
            if(hasModule('Customer')){
                $permission_customers = Permission::whereModel(Customer::class)->get();
            }
            if(hasModule('Client')){
                $permission_clients = Permission::whereModel(Client::class)->get();
            }
            if(hasModule('User')){
                $permission_users = Permission::whereModel(User::class)->get();
            }
            if(hasModule('Member')){
                $permission_members = Permission::whereModel(Member::class)->get();
            }
            if(hasModule('Carousel')){
                $permission_carousels = Permission::whereModel(Carousel::class)->get();
            }
            if(hasModule('Page')){
                $permission_pages = Permission::whereModel(Page::class)->get();
            }
            if(hasModule('Service')){
                $permission_services = Permission::whereModel(Service::class)->get();
                $permission_advantages = Permission::whereModel(Advantage::class)->get();
                $permission_properties = Permission::whereModel(Property::class)->get();
            }
            if(hasModule('Question')){
                $permission_questions = Permission::whereModel(Question::class)->get();
            }
            if(hasModule('Product')){
                $permission_products = Permission::whereModel(Product::class)->get();
            }
            if(hasModule('Download')){
                $permission_downloads = Permission::whereModel(Download::class)->get();
            }
            if(hasModule('Event')){
                $permission_events = Permission::whereModel(Event::class)->get();
            }
            if(hasModule('Portfolio')){
                $permission_portfolios = Permission::whereModel(Portfolio::class)->get();
            }
            if(hasModule('Store')){
                $permission_stores = Permission::whereModel(Store::class)->get();
            }
            if(hasModule('Brand')){
                $permission_brands = Permission::whereModel(Brand::class)->get();
            }
            if(hasModule('Plan')){
                $permission_plans = Permission::whereModel(Plan::class)->get();
            }
            if(hasModule('Sms')){
                $permission_smses = Permission::whereModel(Sms::class)->get();
            }




            return view('core::layout.roles.create',compact(
                'permission_articles',
                'permission_menus',
                'permission_informations',
                'permission_carousels',
                'permission_services',
                'permission_advantages',
                'permission_properties',
                'permission_questions',
                'permission_products',
                'permission_events',
                'permission_downloads',
                'permission_portfolios',
                'permission_clients',
                'permission_members',
                'permission_users',
                'permission_customers',
                'permission_pages',
                'permission_plans',
                'permission_stores',
                'permission_brands',
                'permission_smses'
            ));

        }catch (\Exception $exception){
            return abort('500');
        }


    }


    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(RoleRequest $request)
    {


        try {
            $this->entity->name=$request->input('name');
            $this->entity->token=tokenGenerate();

            $this->entity->save();



            $this->entity->syncPermissions($request->input('permission'));


            return redirect()->route('roles.index')
                ->with('success','Role created successfully');
        }catch (\Exception $exception){
            return abort('500');
        }

    }
    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        try {
            $role = Role::find($id);
            $rolePermissions = Permission::join("role_has_permissions","role_has_permissions.permission_id","=","permissions.id")
                ->where("role_has_permissions.role_id",$id)
                ->get();


            return view('roles.show',compact('role','rolePermissions'));
        }catch (\Exception $exception){
            return abort('500');
        }

    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($token)
    {
        try {

            if(hasModule('Article')){
                $permission_articles = Permission::whereModel(Article::class)->get();
            }
            if(hasModule('Information')){
                $permission_informations = Permission::whereModel(Information::class)->get();
            }
            if(hasModule('Menu')){
                $permission_menus = Permission::whereModel(Menu::class)->get();
            }
            if(hasModule('Customer')){
                $permission_customers = Permission::whereModel(Customer::class)->get();
            }
            if(hasModule('User')){
                $permission_users = Permission::whereModel(User::class)->get();
            }
            if(hasModule('Client')){
                $permission_clients = Permission::whereModel(Client::class)->get();
            }
            if(hasModule('Member')){
                $permission_members = Permission::whereModel(Member::class)->get();
            }
            if(hasModule('Carousel')){
                $permission_carousels = Permission::whereModel(Carousel::class)->get();
            }
            if(hasModule('Page')){
                $permission_pages = Permission::whereModel(Page::class)->get();
            }
            if(hasModule('Service')){
                $permission_services = Permission::whereModel(Service::class)->get();
                $permission_advantages = Permission::whereModel(Advantage::class)->get();
                $permission_properties = Permission::whereModel(Property::class)->get();
            }
            if(hasModule('Question')){
                $permission_questions = Permission::whereModel(Question::class)->get();
            }
            if(hasModule('Product')){
                $permission_products = Permission::whereModel(Product::class)->get();
            }
            if(hasModule('Download')){
                $permission_downloads = Permission::whereModel(Download::class)->get();
            }
            if(hasModule('Event')){
                $permission_events = Permission::whereModel(Event::class)->get();
            }
            if(hasModule('Portfolio')){
                $permission_portfolios = Permission::whereModel(Portfolio::class)->get();
            }
            if(hasModule('Store')){
                $permission_stores = Permission::whereModel(Store::class)->get();
            }
            if(hasModule('Brand')){
                $permission_brands = Permission::whereModel(Brand::class)->get();
            }

Modules/Core/Resources/views/layout/roles/create.blade.php
@extends('core::layout.panel')
@section('pageTitle', 'ایجاد ')
@section('content')
    <div class="padding">
        <div class="row">
            <div class="col-md-12">
                <div class="box">
                    <div class="box-header">
                        <h2>ایجاد </h2>
                        <small>
                            با استفاده از فرم زیر میتوانید مشتری جدید اضافه کنید.
                        </small>
                    </div>
                    <div class="box-divider m-a-0"></div>
                    <div class="box-body">
@include('core::layout.alert-danger')
                        <form id="signupForm" role="form" method="post" action="{{route('roles.store')}}" enctype="multipart/form-data">
                            @csrf
                            <div class="form-group row">
                                <div class="col-sm-3">
                                    <span class="text-danger">*</span>
                                    <label for="name" class="form-control-label">{{__('cms.title')}} </label>
                                    <input type="text" name="name" class="form-control" id="name" required>
                                </div>
                                <div class="col-sm-7">
                                    <span class="text-danger">*</span>
                                  @include('core::layout.roles.list-permission',['data'=>null])

                                </div>

                            </div>


                            <div class="form-group row m-t-md">
                                <div class="col-sm-12">
                                    <button type="submit" class="btn btn-primary pull-right">{{__('cms.add')}} </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection



@section('heads')

    <link href="{{asset('assets/css/validate/screen.css')}}" rel="stylesheet"/>

@endsection()

@section('scripts')


    <script src="{{asset('assets/scripts/validate/jquery.validate.js')}}"></script>


    <script>


        $().ready(function() {
            // validate the comment form when it is submitted
            $("#commentForm").validate();

            // validate signup form on keyup and submit
            $("#signupForm").validate({
                rules: {
                    name: {
                        required: true
                    },
                    permission: {
                        required: true
                    },


                },
                messages: {
                    name:"عنوان الزامی است",
                    permission: "دسترسی  لزامی است",
                }
            });


            //code to hide topic selection, disable for demo
            var newsletter = $("#newsletter");
            // newsletter topics are optional, hide at first
            var inital = newsletter.is(":checked");
            var topics = $("#newsletter_topics")[inital ? "removeClass" : "addClass"]("gray");
            var topicInputs = topics.find("input").attr("disabled", !inital);
            // show when newsletter is checked
            newsletter.click(function() {
                topics[this.checked ? "removeClass" : "addClass"]("gray");
                topicInputs.attr("disabled", !this.checked);
            });
        });
    </script>

@endsection

Modules/Core/Resources/views/layout/roles/edit.blade.php
@extends('core::layout.panel')
@section('pageTitle', ' ویرایش')
@section('content')
    <div class="padding">
        <div class="row">
            <div class="col-md-12">
                <div class="box">
                    <div class="box-header">
                        <div class="pull-left">
                            <h2> {{__('cms.title')}}   {{$item->name}}</h2>
                            <small>
                                با استفاده از فرم زیر میتوانید مقاله مورد نظر را مشاهده کنید.
                            </small>
                        </div>
                        <a onclick="window.print()" class="btn btn-primary btn-sm text-sm text-white pull-right">{{__('cms.print')}} </a>
                    </div>
                    <br>
                    <br>
                    <div class="box-divider m-a-0"></div>
                    <div class="box-body">
                        <form id="signupForm" action="{{route('roles.update', ['role' => $item->token])}}" method="POST" enctype="multipart/form-data">
                            {{csrf_field()}}
                            {{method_field('PATCH')}}
                            <div class="form-group row">
                                <div class="col-sm-3">
                                    <span class="text-danger">*</span>
                                    <label for="name" class="form-control-label">{{__('cms.title')}} </label>
                                    <input type="text" value="{{$item->name}}" name="name" class="form-control" id="name" required>
                                </div>
                                <div class="col-sm-7">
                                    <span class="text-danger">*</span>
                                    @include('core::layout.roles.list-permission',['data'=>$rolePermissions])


                                </div>

                            </div>

                            <div class="form-group row m-t-md">
                                <div class="col-sm-12">
                                    <input type="submit"  class="btn btn-success btn-sm text-sm" value="{{__('cms.update')}} ">
                                </div>
                            </div>
                        </form>

                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection


@section('heads')

    <link href="{{asset('assets/css/validate/screen.css')}}" rel="stylesheet"/>

@endsection()

@section('scripts')


    <script src="{{asset('assets/scripts/validate/jquery.validate.js')}}"></script>


    <script>


        $().ready(function() {
            // validate the comment form when it is submitted
            $("#commentForm").validate();

            // validate signup form on keyup and submit
            $("#signupForm").validate({
                rules: {
                    name: {
                        required: true
                    },
                    permission: {
                        required: true
                    },


                },
                messages: {
                    name:"عنوان الزامی است",
                    permission: "دسترسی  لزامی است",
                }
            });


            //code to hide topic selection, disable for demo
            var newsletter = $("#newsletter");
            // newsletter topics are optional, hide at first
            var inital = newsletter.is(":checked");
            var topics = $("#newsletter_topics")[inital ? "removeClass" : "addClass"]("gray");
            var topicInputs = topics.find("input").attr("disabled", !inital);
            // show when newsletter is checked
            newsletter.click(function() {
                topics[this.checked ? "removeClass" : "addClass"]("gray");
                topicInputs.attr("disabled", !this.checked);
            });
        });
    </script>

@endsection

Modules/Core/Resources/views/layout/roles/index.blade.php
@include('core::layout.modules.index',[

    'title'=>__('core::roles.index'),
    'items'=>$items,
    'model'=>'role',
    'collect'=>__('core::roles.collect'),
    'singular'=>__('core::roles.singular'),
    'create_route'=>['name'=>'roles.create'],
    'edit_route'=>['name'=>'roles.edit','name_param'=>'role'],
    'destroy_route'=>['name'=>'roles.destroy','name_param'=>'role'],
    'datatable'=>[
    __('cms.title')=>'name',
    __('cms.update_date')=>'AgoTimeUpdate',
    __('cms.create_date')=>'TimeCreate',
    ],
        'detail_data'=>[
    __('cms.title')=>'name',
    __('cms.create_date')=>'created_at',
    __('cms.update_date')=>'updated_at',
    ],


])

Modules/Core/Resources/views/layout/roles/nav.blade.php
<li>
        <a href="{{route('roles.index')}}" class="b-success">
                              <span class="nav-icon text-white no-fade">
                                <i class="ion-ios-compose"></i>
                              </span>
            <span class="nav-text"> {{__('core::roles.collect')}}</span>
        </a>
</li>